#include <unistd.h>
#include <stdio.h>
#include <curses.h>
#include <errno.h>

#define CONST               const

typedef unsigned long       DWORD;
typedef int                 BOOL;
typedef unsigned char       BYTE;
typedef unsigned short      WORD;

typedef void* HANDLE;
typedef char  CHAR;
typedef short SHORT;
typedef long  LONG;

typedef CHAR* LPCH;
typedef CHAR* LPSTR;
typedef CONST CHAR* LPCSTR;

typedef DWORD LONGLONG; //what is a 64 bit in gcc??

struct LARGE_INTEGER
{
	LONGLONG QuadPart;
}

#define LOWORD(l)           ((WORD)(l))
#define HIWORD(l)           ((WORD)(((DWORD)(l) >> 16) & 0xFFFF))
#define LOBYTE(w)           ((BYTE)(w))
#define HIBYTE(w)           ((BYTE)(((WORD)(w) >> 8) & 0xFF))

#define CBR_19200           19200
#define CBR_38400           38400
#define CBR_56000           56000
#define CBR_57600           57600

#define Sleep sleep

#define GetLastError() errno
#define CreateMutex(a,b,c) ((HANDLE)1)
#define CreateEvent(a,b,c,d) ((HANDLE)1)
#define CloseHandle(a)
#define WaitForSingleObject(a,b) 1
#define ReleaseMutex(a) 1
#define wsprintf() sprintf()
#define QueryPerformanceCounter(a) 1
#define QueryPerformanceFrequency(a) 1