// SharePoint.h: interface for the CSharePoint class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SHAREPOINT_H__77160816_7C76_4842_8659_822E92AAFF64__INCLUDED_)
#define AFX_SHAREPOINT_H__77160816_7C76_4842_8659_822E92AAFF64__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CDiskImage;

#include "diskImage.h"

class CSharePoint : public CDiskImage  
{
public:
	CSharePoint();
	virtual ~CSharePoint();

	virtual LPCSTR description();
	virtual bool load(LPSTR folderpath, bool isReadOnly);
	virtual WORD readSector(BYTE* sb, WORD sector);
	virtual WORD writeSector(BYTE* sb, WORD sector);
};

#endif // !defined(AFX_SHAREPOINT_H__77160816_7C76_4842_8659_822E92AAFF64__INCLUDED_)
