VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CUI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (c) 2001 Dan Vernon
'
'This program is free software; you can redistribute it and/or modify it under the terms
'of the GNU General Public License as published by the Free Software Foundation; either
'version 2 of the License, or (at your option) any later version. This program is
'distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
'the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details. You should have received a copy of the GNU
'General Public License along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

Private bDetails As Boolean
Private Const border = 100

'Public AOK As Boolean

Public WithEvents sio As Shell
Attribute sio.VB_VarHelpID = -1
Public settings As CSettings

Private iStatusSize As Long

Private bActivated As Boolean

Private bDebugOn As Boolean

Private mainWidth As Long
Private mainHeight As Long

Public WithEvents Main As Form
Attribute Main.VB_VarHelpID = -1
Private WithEvents lstDisks As ListBox
Attribute lstDisks.VB_VarHelpID = -1
Private txtDisk As TextBox
Private txtSector As TextBox
Private txtCommand As TextBox
Private txtSpeed As TextBox
Private txtEmuStatus As TextBox
Private WithEvents cmdOpen As CommandButton
Attribute cmdOpen.VB_VarHelpID = -1
Private WithEvents cmdSharePoint As CommandButton
Attribute cmdSharePoint.VB_VarHelpID = -1
Private WithEvents cmdClose As CommandButton
Attribute cmdClose.VB_VarHelpID = -1
Private WithEvents cmdMoveUp As CommandButton
Attribute cmdMoveUp.VB_VarHelpID = -1
Private WithEvents cmdMoveDown As CommandButton
Attribute cmdMoveDown.VB_VarHelpID = -1
Private lblError As Label
Private txtStatus As TextBox
Private WithEvents cmdDetails As CommandButton
Attribute cmdDetails.VB_VarHelpID = -1

Private WithEvents mnuAbout As Menu
Attribute mnuAbout.VB_VarHelpID = -1
Private WithEvents mnuCreateDiskImage As Menu
Attribute mnuCreateDiskImage.VB_VarHelpID = -1
Private WithEvents mnuDelete As Menu
Attribute mnuDelete.VB_VarHelpID = -1
Private WithEvents mnuMountDiskImage As Menu
Attribute mnuMountDiskImage.VB_VarHelpID = -1
Private WithEvents mnuExit As Menu
Attribute mnuExit.VB_VarHelpID = -1
Private WithEvents mnuReleaseDiskImage As Menu
Attribute mnuReleaseDiskImage.VB_VarHelpID = -1
Private WithEvents mnuSharePoint As Menu
Attribute mnuSharePoint.VB_VarHelpID = -1
Private WithEvents mnuOpen As Menu
Attribute mnuOpen.VB_VarHelpID = -1
Private WithEvents mnuSave As Menu
Attribute mnuSave.VB_VarHelpID = -1
Private WithEvents mnuOptions As Menu
Attribute mnuOptions.VB_VarHelpID = -1

Private pnlTop As PictureBox
Private pnlRight As PictureBox
Private pnlBottom As PictureBox

Public skin As String

Public Sub Bind(f As Form)
    Set Main = f
    setControls
End Sub

Public Sub Release()
    clearControls
End Sub

Private Sub setControls()
    clearControls
    With Main
        Set lstDisks = .lstDisks
        Set txtDisk = .txtDisk
        Set txtSector = .txtSector
        Set txtCommand = .txtCommand
        Set txtSpeed = .txtSpeed
        Set cmdOpen = .cmdOpen
        Set cmdSharePoint = .cmdSharePoint
        Set cmdClose = .cmdClose
        Set cmdMoveUp = .cmdMoveUp
        Set cmdMoveDown = .cmdMoveDown
        Set lblError = .lblError
        Set txtStatus = .txtStatus
        Set cmdDetails = .cmdDetails
        
        Set mnuCreateDiskImage = .mnuCreateDiskImage
        Set mnuAbout = .mnuAbout
        Set mnuDelete = .mnuDelete
        Set mnuMountDiskImage = .mnuMountDiskImage
        Set mnuExit = .mnuExit
        Set mnuReleaseDiskImage = .mnuReleaseDiskImage
        Set mnuSharePoint = .mnuSharePoint
        Set mnuOpen = .mnuOpen
        Set mnuSave = .mnuSave
        Set mnuOptions = .mnuOptions
        Set txtEmuStatus = .txtEmuStatus
        
        On Error Resume Next
        Set pnlTop = .pnlTop
        Set pnlBottom = .pnlBottom
        Set pnlRight = .pnlRight
        On Error GoTo 0
    End With
End Sub

Private Sub clearControls()
    With Main
        Set lstDisks = Nothing
        Set txtDisk = Nothing
        Set txtSector = Nothing
        Set txtCommand = Nothing
        Set txtSpeed = Nothing
        Set cmdOpen = Nothing
        Set cmdSharePoint = Nothing
        Set cmdClose = Nothing
        Set cmdMoveUp = Nothing
        Set cmdMoveDown = Nothing
        Set lblError = Nothing
        Set txtStatus = Nothing
        Set cmdDetails = Nothing
    
        Set mnuCreateDiskImage = Nothing
        Set mnuAbout = Nothing
        Set mnuDelete = Nothing
        Set mnuMountDiskImage = Nothing
        Set mnuExit = Nothing
        Set mnuReleaseDiskImage = Nothing
        Set mnuSharePoint = Nothing
        Set mnuOpen = Nothing
        Set mnuSave = Nothing
        Set mnuOptions = Nothing
        Set txtEmuStatus = Nothing
    
        On Error Resume Next
        Set pnlTop = Nothing
        Set pnlBottom = Nothing
        Set pnlRight = Nothing
        On Error GoTo 0
    End With
End Sub

Public Sub show()
    Main.show
End Sub

Public Sub init0()
    'load Main
End Sub

Public Sub init()
    'load Main
        
    mainWidth = settings.ReadSetting("Width", "8460")
    mainHeight = settings.ReadSetting("Height", "5760")
    If Not pnlTop Is Nothing Then
        Main.Height = mainHeight
        Main.Width = mainWidth
    End If
    
    If Not sio Is Nothing Then
        
        settings.ReadSession DEFAULT_SESSION_KEY
        sio.showDebugMessages = True
        showdisks
    
        sio.serialPort = CByte(settings.ReadSetting("SerialPortNumber", "1"))
        sio.MaxSpeed = CByte(settings.ReadSetting("MaxSIOSpeed", "3"))
        If sio.isStopped Then sio.start
    Else
        sio_Error 42, "unable to locate atariSioDriver.exe version " & VERSION
    End If
End Sub

Private Sub Class_Initialize()
    initSettings
    bDebugOn = settings.ReadSetting("DebugEnabled", "True")
    iStatusSize = settings.ReadSetting("StatusSize", "8192")
    ChangeSkin LCase(settings.ReadSetting("Skin", "atari810"))
End Sub

Public Sub ChangeSettings(ComPort As Integer, Speed As Integer, skin As String)
    ChangeSkin skin
    ChangeComPort ComPort
    ChangeSpeed Speed
End Sub

Public Sub ChangeComPort(i As Integer)
    If Not sio Is Nothing Then
        If i <> sio.serialPort Then
            sio.serialPort = i
        End If
        If sio.isStopped Then sio.start
    End If
End Sub

Public Sub ChangeSpeed(i As Integer)
    If Not sio Is Nothing Then
        sio.MaxSpeed = i
    End If
End Sub

Public Sub ChangeSkin(s As String)
    If Me.skin = s Then Exit Sub
    
    Me.skin = s
    Dim f As Form
    If Not Main Is Nothing Then
        Unload Main
        clearControls
    End If
    
    Select Case skin
    Case "atari810": Set f = New frmMain810
    Case "atari1050": Set f = New frmMain1050
    Case "retrogreen": Set f = New frmMainGreen
    Case "plainjane": Set f = New frmMainPlain
    Case "bigjane": Set f = New frmMainBigJane
    End Select
    Bind f
    
    showdisks
    
    show
End Sub

Private Sub Class_Terminate()
    Set sio = Nothing
    Set settings = Nothing
End Sub

Private Sub cmdClose_Click()
    sio.Release lstDisks.ListIndex + 1
    showdisks
End Sub

Private Sub cmdDetails_Click()
    bDetails = Not bDetails
    If bDetails Then
        cmdDetails.Caption = "<< Hide Details"
        Main.Height = Main.Height + txtStatus.Height + 2 * border
    Else
        cmdDetails.Caption = ">> Show Details"
        Main.Height = Main.Height - txtStatus.Height - 2 * border
    End If
End Sub

Private Sub showdisks()
    Dim lastInd As Integer
    lastInd = lstDisks.ListIndex
    
    If Not sio Is Nothing Then
    
    Dim i As Integer, atrFile As String, j As Integer
    For i = 1 To SIO_MAX_DISKS
        atrFile = sio.diskPath(i)
        j = InStrRev(atrFile, "\")
        If (j) Then
            atrFile = Right(atrFile, Len(atrFile) - j)
        End If
        lstDisks.List(i - 1) = "D" & i & " " & atrFile
    Next
    lstDisks.Refresh
    If lastInd = -1 Then Exit Sub
    lstDisks.Selected(lastInd) = True
    End If
End Sub

Private Sub cmdMoveDown_Click()
    sio.swapDisks lstDisks.ListIndex + 1, lstDisks.ListIndex + 1 + 1
    lstDisks.ListIndex = lstDisks.ListIndex + 1
    showdisks
End Sub

Private Sub cmdMoveUp_Click()
    sio.swapDisks lstDisks.ListIndex + 1, lstDisks.ListIndex + 1 - 1
    lstDisks.ListIndex = lstDisks.ListIndex - 1
    showdisks
End Sub

Private Sub cmdOpen_Click()
    Dim s As String
    s = OpenFile("Open Disk Image", atrFilter, Main.hwnd)
    If Len(s) Then
        sio.mount s, lstDisks.ListIndex + 1, False
    End If
    showdisks
End Sub

Private Sub cmdSharePoint_Click()
    Dim s As String
    s = GetFolder("Select Sharepoint", Main.hwnd)
    If Len(s) Then
        MsgBox "This feature is currently under development!", vbOKOnly, "Atari810"
        'sio.mount s, lstDisks.ListIndex + 1, False
    End If
    showdisks
End Sub

Private Sub main_Activate()
    If bActivated Then Exit Sub
    bActivated = True

    initSettings
    
    Dim showem As Boolean
    showem = CBool(settings.ReadSetting("ShowDetails", "False"))
    If showem Then
        cmdDetails_Click
    End If
End Sub

Private Sub Main_KeyUp(KeyCode As Integer, Shift As Integer)
    If KeyCode = 46 Then 'DEL
        txtStatus.Text = ""
    End If
End Sub

Private Sub main_Load()
    SetWindowLong Main.hwnd, GWL_USERDATA, WINDOW_SIGNATURE
    
    Dim i As Integer
    For i = 1 To 8
        lstDisks.AddItem "D" & i
    Next
    bDetails = False 'initialize
    
    DoEnabling
    
End Sub

Private Sub main_Resize()
    If pnlTop Is Nothing Then Exit Sub
    
    On Error Resume Next
    pnlRight.Top = 0
    pnlRight.Left = Main.ScaleWidth - pnlRight.Width
    pnlRight.Height = lstDisks.Height + pnlTop.Height

    pnlTop.Top = 0
    pnlTop.Left = 0
    pnlTop.Width = Main.ScaleWidth - pnlRight.Width
    
    lstDisks.Top = pnlTop.Height
    lstDisks.Left = txtDisk.Left
    lstDisks.Width = pnlTop.Width - txtDisk.Left
    
    lstDisks.Height = 1710
    
    lblError.Width = Main.ScaleWidth - lblError.Left * 2
    
    txtStatus.Left = lblError.Left
    txtStatus.Top = lblError.Top + lblError.Height + lblError.Left
    txtStatus.Height = Main.ScaleHeight - txtStatus.Top - lblError.Left
    txtStatus.Width = Main.ScaleWidth - txtStatus.Left - lblError.Left
   
    On Error GoTo 0
End Sub

Private Sub Main_Unload(Cancel As Integer)
    If Not sio Is Nothing Then
        settings.WriteSetting "SerialPortNumber", sio.serialPort
        settings.WriteSetting "MaxSIOSpeed", sio.MaxSpeed
    End If
    settings.WriteSetting "StatusSize", iStatusSize
    settings.WriteSetting "DebugEnabled", bDebugOn
    
    settings.WriteSetting "ShowDetails", bDetails
    settings.WriteSetting "Skin", skin
    If Not pnlTop Is Nothing Then
        settings.WriteSetting "Height", Main.Height
        settings.WriteSetting "Width", Main.Width
    End If
    
    If Not sio Is Nothing Then
        settings.WriteCurrentSession DEFAULT_SESSION_KEY
        sio.stop
    End If
    
    settings.Save
    
End Sub

Private Sub Status(msg)
    txtStatus.Text = txtStatus.Text & msg & vbCrLf
    Dim i As Long
    i = Len(txtStatus)
    If i > iStatusSize Then txtStatus.Text = Right(txtStatus, iStatusSize / 2)
    txtStatus.SelStart = Len(txtStatus)
End Sub

Private Sub lstDisks_Click()
    DoEnabling
End Sub

Private Sub mnuAbout_Click()
    frmAbout.show vbModal, Main
End Sub

Private Sub mnuCreateDiskImage_Click()
    frmCreateImage.show vbModal, Main
    showdisks
End Sub

Private Sub mnuOptions_Click()
    
    Dim uiopt As CGUIOptions
    Set uiopt = New CGUIOptions
    
    Dim f As Form
    Select Case skin
    Case "atari810": Set f = New frmOptions810
    Case "atari1050": Set f = New frmOptions1050
    Case "retrogreen": Set f = New frmOptionsGreen
    Case "plainjane": Set f = New frmOptionsPlain
    Case "bigjane": Set f = New frmOptionsPlain
    End Select
    
    uiopt.Bind f
    uiopt.show vbModal, Main
End Sub

Private Sub mnuDelete_Click()
    frmSession.init "delete"
    frmSession.show vbModal, Main
End Sub

Private Sub mnuExit_Click()
    Unload Main
End Sub

Private Sub DoEnabling()
    Dim i As Integer
    
    i = lstDisks.ListIndex
    On Error Resume Next
    cmdOpen.Enabled = i > -1 And Not sio Is Nothing
    cmdSharePoint.Enabled = cmdOpen.Enabled
    mnuMountDiskImage.Enabled = cmdOpen.Enabled
    mnuSharePoint.Enabled = cmdOpen.Enabled
    cmdClose.Enabled = i > -1 And Not sio Is Nothing
    mnuReleaseDiskImage.Enabled = cmdClose.Enabled
    cmdMoveUp.Enabled = i > 0 And Not sio Is Nothing
    cmdMoveDown.Enabled = i > -1 And i < lstDisks.ListCount - 1 And Not sio Is Nothing
    On Error GoTo 0
End Sub

Private Sub mnuMountDiskImage_Click()
    cmdOpen_Click
End Sub

Private Sub mnuOpen_Click()
    frmSession.init "open"
    frmSession.show vbModal, Main
    showdisks
End Sub

Private Sub mnuReleaseDiskImage_Click()
    cmdClose_Click
End Sub

Private Sub mnuSave_Click()
    frmSession.init "save"
    frmSession.show vbModal, Main
End Sub

Private Sub mnuSharePoint_Click()
    cmdSharePoint_Click
End Sub


Private Function CommandToStr(ByVal b1 As Byte, ByVal b2 As Byte, ByVal b3 As Byte, ByVal b4 As Byte, ByVal b5 As Byte)
    CommandToStr = ByteToStr(b1) & " " & ByteToStr(b2) & " " & ByteToStr(b3) & " " & ByteToStr(b4) & " " & ByteToStr(b5)
End Function

Private Function ByteToStr(b1 As Byte)
    ByteToStr = Right("00" & Hex(b1), 2)
End Function

Private Sub ColorIt(c As Control, col As ColorConstants)
    If TypeName(Main) <> "frmMainPlain" And TypeName(Main) <> "frmMainBigJane" Then
        c.ForeColor = col
    End If
End Sub

Private Sub sio_Command(ByVal b1 As Byte, ByVal b2 As Byte, ByVal b3 As Byte, ByVal b4 As Byte, ByVal b5 As Byte, ByVal disk As Byte, ByVal sector As Long, ByVal Command As String, ByVal speedIndex As Byte)
    txtSector.Text = sector
    If disk > 0 And disk < SIO_MAX_DISKS Then
        txtDisk.Text = "D" & disk
    Else
        txtDisk.Text = "N/A"
    End If
    txtCommand.Text = UCase(Command)
    If speedIndex = 2 Then
        ColorIt txtSpeed, vbYellow
        txtSpeed.Text = "HIGH (2X)"
    ElseIf speedIndex = 3 Then
        ColorIt txtSpeed, vbRed
        txtSpeed.Text = "ULTRA(3X)"
    Else
        ColorIt txtSpeed, vbGreen
        txtSpeed.Text = "NORM (1X)"
    End If
    Dim sDev As String
    If disk = 16 Then
        sDev = "P"
    Else
        sDev = "D" & disk
    End If
    
    Status CommandToStr(b1, b2, b3, b4, b5) & " [" & sDev & ": " & Command & " sector " & sector & "]"
End Sub

Private Sub sio_Debug(ByVal msg As String)
    If bDebugOn Then Status msg
End Sub
Private Sub sio_Error(ByVal number As Long, ByVal msg As String)
    ColorIt lblError, vbRed
    lblError.Caption = msg
    Status "error: " & number & " " & msg
    EmuStatus
End Sub

Private Sub sio_Status(ByVal msg As String)
    'If Not AOK Then Exit Sub
    ColorIt lblError, vbGreen
    lblError.Caption = msg
    Status msg
    EmuStatus
End Sub

Private Sub EmuStatus()
    If Not sio Is Nothing Then
        If sio.isStopped Then
            ColorIt txtEmuStatus, vbRed
            txtEmuStatus = "HALTED"
        Else
            ColorIt txtEmuStatus, vbGreen
            txtEmuStatus = "ACTIVE"
        End If
    End If
End Sub

Private Sub initSettings()
    If Not settings Is Nothing Then Exit Sub
    Dim xmlPath As String
    xmlPath = App.path & "\atari810.xml"
    Set settings = New CSettings
    settings.init xmlPath, "Atari810"
End Sub


Public Sub Error(msg As String, Optional src As String)
    If Len(src) > 0 Then
        sio_Error 42, msg & " at " & src
    Else
        sio_Error 42, msg
    End If
End Sub
