VERSION 5.00
Begin VB.Form frmSplash 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Atari810"
   ClientHeight    =   3120
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4020
   ControlBox      =   0   'False
   Icon            =   "frmSplash.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   3120
   ScaleWidth      =   4020
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Visible         =   0   'False
   Begin VB.CommandButton cmdOK 
      Caption         =   "OK"
      Height          =   435
      Left            =   1440
      TabIndex        =   2
      Top             =   2580
      Visible         =   0   'False
      Width           =   1245
   End
   Begin VB.Timer Timer1 
      Left            =   3420
      Top             =   120
   End
   Begin VB.Label lblDetails 
      ForeColor       =   &H00000000&
      Height          =   525
      Left            =   120
      TabIndex        =   3
      Top             =   1920
      Visible         =   0   'False
      Width           =   3825
   End
   Begin VB.Label lblNotice 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   885
      Left            =   150
      TabIndex        =   1
      Top             =   840
      Visible         =   0   'False
      Width           =   3705
   End
   Begin VB.Label Label1 
      Alignment       =   2  'Center
      Caption         =   "Configuring atariSioDriver, please wait...."
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   570
      TabIndex        =   0
      Top             =   210
      Width           =   2925
   End
End
Attribute VB_Name = "frmSplash"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Copyright (c) 2001 Dan Vernon
'
'This program is free software; you can redistribute it and/or modify it under the terms
'of the GNU General Public License as published by the Free Software Foundation; either
'version 2 of the License, or (at your option) any later version. This program is
'distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
'the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details. You should have received a copy of the GNU
'General Public License along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

Private Const MODULE = "frmSplash"

Private FirstError As String

Private Sub cmdOK_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    gUI.init0
    If IsDriverOK() Then
        Timer1.Interval = 5 ' everything's A-OK
    Else
        Timer1.Interval = 10 ' no atariSioDriver
    End If
End Sub

Private Sub Timer1_Timer()
    Const src = MODULE & ".Timer1_Timer"
    
    Timer1.Enabled = False
    
    If Timer1.Interval = 5 Then 'no problems, initialize and bail
        gUI.init
        gUI.show
        Unload Me
    
    ElseIf Timer1.Interval = 10 Then 'gsio driver not registered, pause for 3 seconds
        Me.show , gUI.Main
        
        On Error Resume Next
        Dim path As String
        path = App.path
        If Mid(path, Len(path), 1) <> "\" Then
            path = path & "\"
        End If
        
        Err.Clear
        
        Shell path & "atariSioDriver.exe /regserver", vbHide
        
        If Err.number <> 0 Then
            gUI.Error Err.description, src & ".Shell"
            If Len(FirstError) = 0 Then
                FirstError = Err.description
            End If
        End If
            
        On Error GoTo 0
 
        Timer1.Interval = 3000
        Timer1.Enabled = True
    
    ElseIf Timer1.Interval = 3000 Then ' show main form, pause for 1 second
        Timer1.Interval = 1000
        gUI.show
        Timer1.Enabled = True
    
    ElseIf Timer1.Interval = 1000 Then ' try initializing driver again
        If Not IsDriverOK(True) Then
            Set gUI.sio = Nothing
            gUI.init
            cmdOK.Visible = True
            lblNotice.Caption = "Error: Unable to locate atariSioDriver.exe version " & VERSION & ".  Atari810 will not function correctly unless this file is in the same directory."
            lblDetails.Caption = "Error Details: " & FirstError
            lblDetails.Visible = True
            lblNotice.Visible = True
        Else
            gUI.init
            Unload Me
        End If
    End If

End Sub

Public Function IsDriverOK(Optional showErrors As Boolean) As Boolean
    Const src = MODULE & ".IsDriverOK"
    
    On Error Resume Next
    Err.Clear
    Set gUI.sio = New atariSioDriver.Shell
    If Err.number <> 0 Then
        If showErrors Then
            gUI.Error Err.description, src & ".New"
            If Len(FirstError) = 0 Then
                FirstError = Err.description
            End If
        End If
        
    ElseIf gUI.sio.versionString <> VERSION Then
        If showErrors Then
            gUI.Error "Incompatible version found (" & gUI.sio.versionString & ")", src & ".versionString"
            If Len(FirstError) = 0 Then
                FirstError = "Incompatible version found (" & gUI.sio.versionString & ")"
            End If
        End If
    End If
    
    IsDriverOK = (gUI.sio.versionString = VERSION)
    
    On Error GoTo 0
End Function


