/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version. This program is
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// Shell.h : Declaration of the Shell

#ifndef __Shell_H_
#define __Shell_H_

/////////////////////////////////////////////////////////////////////////////
// Shell
class Shell :
{
public:
	Shell();
	~Shell();
	void Debug(LPCSTR msg);
	void Status(LPCSTR msg);
	void Command(BYTE b1,BYTE b2,BYTE b3,BYTE b4,BYTE b5,BYTE disk,WORD sector,LPCSTR command);
	void Error(LONG number, LPCSTR msg);

};

#endif //__Shell_H_
