Attribute VB_Name = "A810Main"
'Copyright (c) 2001 Dan Vernon
'
'This program is free software; you can redistribute it and/or modify it under the terms
'of the GNU General Public License as published by the Free Software Foundation; either
'version 2 of the License, or (at your option) any later version. This program is
'distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
'the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details. You should have received a copy of the GNU
'General Public License along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

Public Const VERSION = "1.4d"

Public Const SIO_MAX_DISKS = 8
Public Const DEFAULT_SESSION_KEY = "@Atari810@"
Public atrFilter As String

Type DISK_IMAGE_TEMPLATE
    description As String
    sectorcount As Long
    sectorsize As Long
End Type

Public DiskImageTemplates() As DISK_IMAGE_TEMPLATE
Public gUI As CUI

Public Const WINDOW_SIGNATURE = &H89AA37BB

Public Sub Main()
    Dim x As Long
    atrFilter = "All (*.*)" & Chr(0) & "*.*" & Chr(0) & "Atari Disk Image (*.atr)" & Chr(0) & "*.atr" & Chr(0)
    
    Dim hwnd As Long
    hwnd = FindMyWindow(WINDOW_SIGNATURE, "Atari810")
        
    Set gUI = New CUI
    
    If hwnd Then
        ShowWindow hwnd, SW_SHOWNORMAL
        SetForegroundWindow hwnd
    Else
        load frmSplash
    End If
End Sub
