VERSION 5.00
Begin VB.Form frmSession 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Atari810"
   ClientHeight    =   4890
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6105
   Icon            =   "frmSession.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4890
   ScaleWidth      =   6105
   ShowInTaskbar   =   0   'False
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton cmdCancel 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      CausesValidation=   0   'False
      Height          =   405
      Left            =   4080
      TabIndex        =   3
      Top             =   4380
      Width           =   945
   End
   Begin VB.ListBox lstSessionsToDelete 
      Height          =   4155
      Left            =   90
      MultiSelect     =   2  'Extended
      TabIndex        =   0
      Top             =   90
      Width           =   5925
   End
   Begin VB.TextBox txtName 
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   4380
      Width           =   3855
   End
   Begin VB.CommandButton cmdAction 
      Caption         =   "Open"
      Default         =   -1  'True
      Height          =   405
      Left            =   5100
      TabIndex        =   4
      Top             =   4380
      Width           =   945
   End
   Begin VB.ListBox lstSessions 
      Height          =   4155
      Left            =   90
      TabIndex        =   1
      Top             =   90
      Width           =   5925
   End
End
Attribute VB_Name = "frmSession"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Copyright (c) 2001 Dan Vernon
'
'This program is free software; you can redistribute it and/or modify it under the terms
'of the GNU General Public License as published by the Free Software Foundation; either
'version 2 of the License, or (at your option) any later version. This program is
'distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
'the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details. You should have received a copy of the GNU
'General Public License along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

Private mmode As String
Private mactiveList As ListBox

Private Sub cmdAction_Click()
    Dim i As Long
    If mmode = "delete" Then
        If mactiveList.SelCount > 0 Then
            MsgBox "Permanently delete " & mactiveList.SelCount & " items?", vbQuestion Or vbOKCancel, "Atari810"
            For i = 0 To mactiveList.ListCount - 1
                If mactiveList.Selected(i) Then
                    gUI.settings.DeleteSession mactiveList.List(i)
                End If
            Next
        End If
        showSessions
    ElseIf mmode = "save" Then
        If gUI.settings.SessionExists(txtName.Text) Then
            MsgBox "Overwrite the existing session?", vbQuestion Or vbOKCancel, "Atari810"
        End If
        gUI.settings.WriteCurrentSession txtName.Text
        Unload Me
    ElseIf mmode = "open" Then
        gUI.settings.ReadSession txtName.Text
        Unload Me
    End If
End Sub

Public Sub init(mode As String)
    mmode = LCase(mode)
End Sub

Private Sub cmdCancel_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Dim l As ListBox
    
    lstSessions.Visible = False
    lstSessionsToDelete.Visible = False
    If mmode = "open" Then
        Set mactiveList = lstSessions
        txtName.Enabled = False
        cmdAction.Caption = "Open"
    ElseIf mmode = "save" Then
        Set mactiveList = lstSessions
        cmdAction.Caption = "Save"
    ElseIf mmode = "delete" Then
        txtName.Visible = False
        Set mactiveList = lstSessionsToDelete
        cmdAction.Caption = "Delete"
        cmdCancel.Caption = "Close"
    End If
    
    mactiveList.Visible = True
    
    showSessions

    DoEnabling
End Sub

Private Function showSessions()
    mactiveList.Clear
    Dim a() As String
    a = gUI.settings.SessionNames
    
    Dim i As Integer
    i = -1
    On Error Resume Next
    i = UBound(a)
    On Error GoTo 0
    If i > -1 Then
    
        SortNames a
        
        For i = 0 To UBound(a)
            mactiveList.AddItem a(i)
        Next
    End If
End Function

Private Function SortNames(a() As String)
    Dim i As Long
    Dim j As Long
    Dim sLeastValue As String
    Dim iLeastIndex As Long
    Dim oSwap As String
    
    For i = 0 To UBound(a)
        sLeastValue = a(i)
        iLeastIndex = i
        
        For j = i + 1 To UBound(a)
            If UCase(a(j)) < UCase(sLeastValue) Then
                ' Save the new smallest value.
                sLeastValue = a(j)
                iLeastIndex = j
            End If
        Next j
        
        If iLeastIndex <> i Then
            ' Swap items i and iLeastIndex.
            oSwap = a(i)
            a(i) = a(iLeastIndex)
            a(iLeastIndex) = oSwap
        End If
    Next i
   
    SortNames = a
End Function

Private Sub lstSessions_Click()
    txtName = mactiveList.List(mactiveList.ListIndex)
End Sub

Private Sub lstSessions_DblClick()
    txtName = mactiveList.List(mactiveList.ListIndex)
    cmdAction_Click
End Sub

Private Sub lstSessionsToDelete_Click()
    txtName = mactiveList.List(mactiveList.ListIndex)
End Sub

Private Sub lstSessionsToDelete_DblClick()
    txtName = mactiveList.List(mactiveList.ListIndex)
    cmdAction_Click
End Sub

Private Sub txtName_Change()
    DoEnabling
End Sub

Private Sub DoEnabling()
    cmdAction.Enabled = Len(txtName.Text) > 0
End Sub
